"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isImportedByLib = isImportedByLib;
exports.isCalleeImportedBySfc = isCalleeImportedBySfc;

var types = _interopRequireWildcard(require("@babel/types"));

var _index = require("./index");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function isImportedByLib(identifier, path) {
  var _path$scope$getBindin;

  var libName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [_index.SFC_LIB];

  if (!Array.isArray(libName)) {
    libName = [libName];
    libName.push(_index.SFC_LIB);
  }

  var bindingPath = (_path$scope$getBindin = path.scope.getBinding(identifier)) === null || _path$scope$getBindin === void 0 ? void 0 : _path$scope$getBindin.path;

  if (types.isImportDeclaration(bindingPath === null || bindingPath === void 0 ? void 0 : bindingPath.parent)) {
    var sourceValue = bindingPath === null || bindingPath === void 0 ? void 0 : bindingPath.parent.source.value;
    return sourceValue != null ? libName.includes(sourceValue) : false;
  }
}

function isCalleeImportedBySfc(callee, path, libName, customImportName) {
  if (types.isIdentifier(callee)) {
    return callee.name === (customImportName ? customImportName.name : _index.SFC_FUNC) && (customImportName || isImportedByLib(callee.name, path, libName));
  } else if (types.isMemberExpression(callee)) {
    return types.isIdentifier(callee.object) && callee.object.name === (customImportName ? customImportName.name : _index.SFC_FUNC) && (customImportName || isImportedByLib(callee.object.name, path, libName));
  }
}